apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ kibana_name }}
  name: {{ kibana_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ kibana_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ kibana_name }}
  strategy:
    type: RollingUpdate
{% else %}
      name: {{ kibana_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ kibana_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ kibana_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ kibana_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: ELASTICSEARCH_HOSTS
          value: http://{{ elasticsearch_name }}-client.{{ namespace }}.svc.{{ cluster_domain }}:9200
        - name: ELASTICSEARCH_REQUESTTIMEOUT
          value: "{{ kibana_elasticsearch_request_timeout }}000"
        - name: XPACK_SECURITY_ENABLED
{% if kibana_tag is match('^7') %}
          value: "false"
{% else %}
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='kibana'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='kibana'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 10
          initialDelaySeconds: 30
          periodSeconds: 10
          tcpSocket:
            port: 5601
          timeoutSeconds: 5
        name: kibana
        ports:
        - containerPort: 5601
        readinessProbe:
          failureThreshold: 10
          httpGet:
            path: /api/status
            port: 5601
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ kibana_cpu_limit }}"
            memory: "{{ kibana_memory_limit }}"
          requests:
            cpu: "{{ kibana_cpu_request }}"
            memory: "{{ kibana_memory_request }}"
{% if k8s_flavor == 'kubernetes' %}
        securityContext:
          allowPrivilegeEscalation: false
          runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
        volumeMounts:
        - mountPath: /usr/share/kibana/plugins
          name: plugins
{% if kibana_do_lemon or kibana_do_ldap %}
      - env:
        - name: AUTH_METHOD
{% if kibana_do_lemon %}
          value: oidc
{% else %}
          value: ldap
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: OIDC_CALLBACK_URL
{% if kibana_do_lemon %}
          value: /oauth2/callback
        - name: OIDC_CLIENT_ID
          value: whitepages
        - name: OIDC_CLIENT_SECRET
          valueFrom:
            secretKeyRef:
              key: kibana-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OIDC_CRYPTO_SECRET
          valueFrom:
            secretKeyRef:
              key: oidc-crypto-secret
              name: {{ kibana_name }}
        - name: OIDC_META_URL
          value: /.well-known/openid-configuration
        - name: OIDC_PORTAL
          value: {{ lemon_portal }}
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: client_secret_basic
{% else %}
          value: ""
        - name: OIDC_CLIENT_ID
          value: ""
        - name: OIDC_CLIENT_SECRET
          value: ""
        - name: OIDC_CRYPTO_SECRET
          value: ""
        - name: OIDC_META_URL
          value: ""
        - name: OIDC_PORTAL
          value: ""
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: ""
{% endif %}
{% if kibana_do_ldap and not kibana_do_lemon %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=authproxy,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: authproxy-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if kibana_do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ kibana_ldap_user_objectclass }}
{% endif %}
        - name: PING_PATH
          value: ""
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USER_FILTER
          value: ""
        - name: PING_PATH
          value: /ping
{% endif %}
        - name: PROXY_BACKEND_HOST
          value: 127.0.0.1
        - name: PROXY_BACKEND_PORT
          value: "5601"
        - name: PROXY_BACKEND_PROTO
          value: http
        - name: PROXY_HTTP_PORT
          value: "8080"
        - name: PROXY_PROTO
          value: http
        - name: PROXY_SERVER_NAME
          value: {{ kibana_fqdn }}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='authproxy'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='authproxy'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            httpHeaders:
            - name: Host
{% if kibana_do_lemon %}
              value: {{ kibana_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
{% if kibana_do_lemon %}
              value: {{ kibana_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ authproxy_cpu_limit }}"
            memory: "{{ authproxy_memory_limit }}"
          requests:
            cpu: "{{ authproxy_cpu_request }}"
            memory: "{{ authproxy_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if (kibana_do_ldap or kibana_do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: temp
          subPath: apache
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: certs
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: temp
          subPath: empty
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9113
{% endif %}
{% endif %}
{% endif %}
{% if do_exporters %}
      initContainers:
      - command:
        - /bin/bash
        - "-c"
        - |
            set -xe
            rm -rf plugins/lost+found
            if ! ./bin/kibana-plugin list | grep prometheus-exporter >/dev/null; then
                if ! ./bin/kibana-plugin install "{{ kibana_exporter_plugin }}"; then
                    echo WARNING: failed to install Kibana exporter plugin
                fi
            fi
        env:
        - name: ELASTICSEARCH_HOSTS
          value: http://{{ elasticsearch_name }}-client.{{ namespace }}.svc.{{ cluster_domain }}:9200
        - name: XPACK_SECURITY_ENABLED
          value: "false"
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='kibana'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        name: init
{% if k8s_flavor == 'kubernetes' %}
        securityContext:
          runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
        volumeMounts:
        - mountPath: /usr/share/kibana/plugins
          name: plugins
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ kibana_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if kibana_do_lemon or kibana_do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if (kibana_do_ldap or kibana_do_lemon) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
      - emptyDir: {}
        name: temp
{% endif %}
      - emptyDir: {}
        name: plugins
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='kibana'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - kibana
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='kibana'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if kibana_do_lemon or kibana_do_ldap %}
{% if (opsimages | json_query("[?name=='authproxy'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - authproxy
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='authproxy'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
  - type: ConfigChange
{% endif %}
